unit SmoothText3DUnit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls, SmoothText3D;

type
  TForm1 = class(TForm)
    Button1: TButton;
    SmoothFontManager3D1: TSmoothFontManager3D;
    SmoothLabel3D1: TSmoothLabel3D;
    SmoothLabel3D2: TSmoothLabel3D;
    SmoothLabel3D3: TSmoothLabel3D;
    SmoothLabel3D4: TSmoothLabel3D;
    SmoothLabel3D5: TSmoothLabel3D;
    Panel1: TPanel;
    SmoothLabel3D7: TSmoothLabel3D;
    SmoothLabel3D8: TSmoothLabel3D;
    SmoothLabel3D6: TSmoothLabel3D;
    Timer1: TTimer;
    procedure Button1Click(Sender: TObject);
    procedure FormPaint(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
  private
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure Demo2;
begin
  with Form1 do
    begin
    with SmoothLabel3D1, Font3D do
      begin
      Font.Size := 24;
      Border.Height := 1.5;
      Caption := 'Altitude = 2.6';
      Altitude := 2.6;
      Shadow.Style := sfssSharp;
      Update;
      end;
    with SmoothLabel3D2, Font3D do
      begin
      Font.Size := 24;
      Border.Color := clBlack;
      FrontColor := clGray;
      Border.Height := 1.5;
      Caption := 'Altitude = 5';
      Altitude := 5;
      Shadow.Style := sfssSharp;
      Update;
      end;
    with SmoothLabel3D3, Font3D do
      begin
      Caption := 'Altitude = 7.9';
      Altitude := 7.9;
      Shadow.Style := sfssSharp;
      Update;
      end;
    with SmoothLabel3D4, Font3D do
      begin
      Border.Height := 3;
      Caption := 'ViewDirection = 135';
      ViewDirection := 135;
      Altitude := 5;
      Shadow.Style := sfssSharp;
      Update;
      end;
     with SmoothLabel3D5, Font3D do
      begin
      Border.Height := 3;
      Caption := 'ViewDirection = 20';
      ViewDirection := 20;
      Altitude := 5;
      Shadow.Style := sfssSharp;
      Update;
      end;
     with SmoothLabel3D6, Font3D do
      begin
      Border.Height := 3;
      Caption := 'ViewDirection = 220';
      ViewDirection := 220;
      Altitude := 5;
      Shadow.Style := sfssSharp;
      Visible := true;
      Update;
      end;
    end;
end;

procedure Demo3;
begin
  with Form1 do
    begin
    with SmoothLabel3D1, Font3D do
      begin
      Border.Height := 1.5;
      Caption := 'Shadow.Color = 25';
      Shadow.Color := 25;
      Shadow.Style := sfssSharp;
      Update;
      end;
    with SmoothLabel3D2, Font3D do
      begin
      Border.Height := 1.5;
      Caption := 'Shadow.Color = 70';
      Shadow.Color := 70;
      Altitude := 5;
      Shadow.Style := sfssSharp;
      Update;
      end;
    with SmoothLabel3D3, Font3D do
      begin
      Border.Height := 1.5;
      Caption := 'Shadow.Color = 190';
      Shadow.Color := 190;
      ViewDirection := 135;
      Altitude := 5;
      Shadow.Style := sfssSharp;
      Update;
      end;
    with SmoothLabel3D4, Font3D do
      begin
      Border.Height := 1.5;
      Caption := 'Shadow.Style = None';
      Altitude := 5;
      Shadow.Style := sfssNone;
      Update;
      end;
     with SmoothLabel3D5, Font3D do
      begin
      Border.Height := 1.5;
      Caption := 'Shadow.Style = Sharp';
      ViewDirection := 135;
      Altitude := 5;
      Shadow.Style := sfssSharp;
      Update;
      end;
     with SmoothLabel3D6, Font3D do
      begin
      Border.Height := 1.5;
      Caption := 'Shadow.Style = Diffuse';
      ViewDirection := 135;
      Altitude := 5;
      Shadow.Style := sfssDiffuse;
      Update;
      end;
    end;
end;

procedure Demo4;
begin
  with Form1 do
    begin
    with SmoothLabel3D1, Font3D, Gradient do
      begin
      Altitude := 5;
      Border.EffectColor := 1.5;
      Active := true;
      BeginColor := clWhite;
      EndColor := clBlack;
      Kind := sfgkVertical;
      Caption := 'Gradient.Kind = Vertical';
      Shadow.Color := 32;
      Update;
      end;
    with SmoothLabel3D2, Font3D, Gradient do
      begin
      Altitude := 5;
      Border.EffectColor := 1.5;
      Active := true;
      BeginColor := clWhite;
      EndColor := clBlack;
      Kind := sfgkHorizontal;
      Caption := 'Gradient.Kind = Horizontal';
      Shadow.Color := 32;
      Update;
      end;
    with SmoothLabel3D3, Font3D, Gradient do
      begin
      Altitude := 5;
      Border.EffectColor := 1.5;
      Active := true;
      BeginColor := clWhite;
      EndColor := clBlack;
      Kind := sfgkHorizontal;
      Caption := 'Gradient.BeginColor = clWhite; ';
      Shadow.Color := 32;
      Shadow.Style := sfssSharp;
      Update;
      end;
    with SmoothLabel3D4, Font3D, Gradient do
      begin
      Altitude := 5;
      Border.EffectColor := 1.5;
      Active := true;
      BeginColor := clWhite;
      EndColor := clBlack;
      Kind := sfgkHorizontal;
      Caption := 'Gradient.EndColor = clBlack';
      Shadow.Color := 32;
      Shadow.Style := sfssSharp;
      Update;
     end;
     with SmoothLabel3D5, Font3D, Gradient do
      begin
      Altitude := 5;
      Border.EffectColor := 1.5;
      Active := true;
      BeginColor := clRed;
      EndColor := clBlue;
      Kind := sfgkHorizontal;
      Caption := 'Gradient.BeginColor = clRed; ';
      Shadow.Color := 32;
      Shadow.Style := sfssSharp;
      Update;
      end;
    with SmoothLabel3D6, Font3D, Gradient do
      begin
      Altitude := 5;
      Border.EffectColor := 1.5;
      Active := true;
      BeginColor := clRed;
      EndColor := clBlue;
      Kind := sfgkHorizontal;
      Caption := 'Gradient.EndColor = clBlue';
      Shadow.Color := 32;
      Shadow.Style := sfssSharp;
      Update;
      end;
    end;
end;

procedure Demo5;
begin
  with Form1 do
    begin
    with SmoothLabel3D1, Font3D, Gradient do
      begin
      Font.Style := Font.Style + [fsBold];
      Border.Height := 2;
      Caption := 'Site = Flying';
      Site := sfpFlying;
      BeginColor := clWhite;
      EndColor := clBlack;
      Kind := sfgkVertical;
      Shadow.Color := 64;
      Update;
      end;
    with SmoothLabel3D2, Font3D, Gradient do
      begin
      Font.Style := Font.Style + [fsBold];
      Border.Height := 2;
      Caption := 'Site = Raised';
      Site := sfpRaised;
      BeginColor := clWhite;
      EndColor := clBlack;
      Kind := sfgkVertical;
      Shadow.Color := 64;
      Update;
      end;
    with SmoothLabel3D3, Font3D, Gradient do
      begin
      Font.Style := Font.Style + [fsBold];
      Border.Height := 2;
      Caption := 'Site = Lowered';
      Site := sfpLowered;
      BeginColor := clWhite;
      EndColor := clBlack;
      Kind := sfgkVertical;
      Update;
      end;
    with SmoothLabel3D4, Font3D, Gradient do
      begin
      Caption := 'CharacterMargin = 0';
      CharacterMargin := 0;
      BeginColor := clWhite;
      EndColor := clBlack;
      Kind := sfgkVertical;
      Update;
      end;
    with SmoothLabel3D5, Font3D, Gradient do
      begin
      Caption := 'CharacterMargin = 3';
      CharacterMargin := 3;
      BeginColor := clWhite;
      EndColor := clBlack;
      Kind := sfgkVertical;
      Update;
      end;
    with SmoothLabel3D6, Font3D, Gradient do
      begin
      Caption := 'CharacterMargin = 10';
      CharacterMargin := 10;
      BeginColor := clWhite;
      EndColor := clBlack;
      Kind := sfgkVertical;
      Update;
      end;
    end;
end;

procedure Demo6;
begin
  with Form1 do
    begin
    SmoothLabel3D4.Visible := false;
    SmoothLabel3D5.Visible := false;
    SmoothLabel3D6.Visible := false;
    with SmoothLabel3D1, Font3D do
      begin
      Bitmap.LoadFromFile ('Tempgrym.BMP');
      Caption := 'Bitmap';
      Update;
      end;
    with SmoothLabel3D2, Font3D do
      begin
      Caption := 'Bitmap';
      Site := sfpFlying;
      Bitmap.LoadFromFile ('Marbl03m.BMP');
      Update;
      end;
    with SmoothLabel3D3, Font3D do
      begin
      Caption := 'Bitmap';
      Site := sfpFlying;
      Bitmap.LoadFromFile ('Wood13m.BMP');
      Update;
      end;
    end;
end;

function GetTrueTypeFontName : string;
var
  TextMetrics : TTextMetric;
begin
  repeat
    Result := Screen.Fonts[Random(Screen.Fonts.Count)];
    Form1.Canvas.Font.Name := Result;
    GetTextMetrics (Form1.Canvas.Handle, TextMetrics);
  until (TextMetrics.tmPitchAndFamily and TMPF_TrueType) = TMPF_TrueType;
end;

procedure FillLabels (SmoothLabel3D:TSmoothLabel3D);
var
  FontName : string;
begin
  FontName := GetTrueTypeFontName;
  SmoothLabel3D.Font.Name := FontName;
  SmoothLabel3D.Caption := 'Name = ' + FontName;
  SmoothLabel3D.Update;
end;

procedure DemoX;
begin
  with Form1 do
    begin
    Button1.Visible := false;
    Randomize;
    Timer1.Enabled := true;
    FillLabels (SmoothLabel3D1);
    end;
end;

var
  i : integer = 1;
procedure TForm1.Button1Click(Sender: TObject);
begin
  inc (i);
  case i of
    2 : Demo2;
    3 : Demo3;
    4 : Demo4;
    5 : Demo5;
    6 : Demo6;
    else DemoX;
    end;
end;

procedure TForm1.FormPaint(Sender: TObject);
begin
  SmoothLabel3D7.Update;
  SmoothLabel3D8.Update;
end;

var
  TimerCount : integer = 1;
procedure TForm1.Timer1Timer(Sender: TObject);
begin
  case TimerCount mod 3 of
    0 : FillLabels (SmoothLabel3D1);
    1 : FillLabels (SmoothLabel3D2);
    2 : FillLabels (SmoothLabel3D3);
    end;
  inc (TimerCount);
end;

procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  //SmoothFontManager3D1.UseDiskCache := false;
end;

end.
